发布时间 :2005-01-24 00:00:00
修订时间 :2008-09-05 16:45:21

[原文]Stack-based buffer overflow in DataRescue Interactive Disassembler (IDA) Pro 4.7 allows attackers to execute arbitrary code via a PE file with an Import Address Table containing a long import library name.

[CNNVD]DataRescue IDAPro 缓冲区溢出漏洞(CNNVD-200501-267)

        DataRescue Interactive Disassembler(IDA)是一款强大的反汇编和调试工具。
        IDA Pro4.7版本中存在堆栈溢出漏洞。
        攻击者可利用一个在Import Address Table中包含超长Import library名的PE文件,触发溢出,执行任意代码。

- CVSS (基础分值)

CVSS分值: 7.5 [严重(HIGH)]
机密性影响: PARTIAL [很可能造成信息泄露]
完整性影响: PARTIAL [可能会导致系统文件被修改]
可用性影响: PARTIAL [可能会导致性能下降或中断资源访问]
攻击复杂度: LOW [漏洞利用没有访问限制 ]
攻击向量: [--]
身份认证: NONE [漏洞利用无需身份认证]

- CPE (受影响的平台与产品)


- OVAL (用于检测的技术细节)


- 官方数据库链接
(官方数据源) MITRE
(官方数据源) NVD
(官方数据源) CNNVD

- 其它链接及资源
(VENDOR_ADVISORY)  XF  database-ida-portable-executable-bo(19042)
(VENDOR_ADVISORY)  IDEFENSE  20050124 DataRescue Interactive Disassembler Pro Buffer Overflow Vulnerability
(UNKNOWN)  BID  12353

- 漏洞信息

DataRescue IDAPro 缓冲区溢出漏洞
高危 缓冲区溢出
2005-01-24 00:00:00 2005-10-20 00:00:00
        DataRescue Interactive Disassembler(IDA)是一款强大的反汇编和调试工具。
        IDA Pro4.7版本中存在堆栈溢出漏洞。
        攻击者可利用一个在Import Address Table中包含超长Import library名的PE文件,触发溢出,执行任意代码。

- 公告与补丁


- 漏洞信息 (F35881)

iDEFENSE Security Advisory 2005-01-24.t (PacketStormID:F35881)
2005-01-25 00:00:00
iDefense Labs,Lord Yup

iDEFENSE Security Advisory 01.24.05 - Exploitation of a buffer overflow vulnerability in DataRescue Inc.'s Interactive Disassembler Pro (IDA Pro) allows attackers to execute arbitrary code under the context of the logged on user.

DataRescue Interactive Disassembler Pro Buffer Overflow Vulnerability

iDEFENSE Security Advisory 01.24.05
January 24, 2005


DataRescue Inc.'s IDA Pro is a Windows or Linux hosted multi-processor
disassembler and debugger providing a multitude of features. More
information is available at:


Exploitation of a buffer overflow vulnerability in DataRescue Inc.'s
Interactive Disassembler Pro (IDA Pro) allows attackers to execute
arbitrary code under the context of the logged on user.

The problem specifically exists in the code responsible for parsing the
Portable Executable import directory. The import directory lists all the
symbols imported by the PE file and is stored as an array of data
structures. Each data structure contains the name of the imported
library and a list of function pointers, known as the Import Address
Table. A stack-based buffer overflow occurs when parsing long import
library names in the following snippet of assembly from ida.wll
(IDA Pro v4.7):

    0x100838BB LEA EDX, [EBP-30C]
    0x100838C1 PUSH DWORD PTR [EBP+8]
    0x100838C4 PUSH EDX
    0x100838C5 CALL ida.#835

"EBP+8" from above represents the attacker-supplied source buffer and
"EBP-30C" represents the static stack-based destination buffer of
approximately 800 bytes. The "ida_835" procedure performs an unchecked
string copy overwriting a stored return address and allowing an attacker
to redirect CPU flow to eventually execute arbitrary code.


Exploitation of the described vulnerability allows attackers to execute
arbitrary code under the context of the logged in user. Exploitation
requires that an attacker convince a target user to open a malicious
Portable Executable file with a vulnerable version of IDA Pro. IDA Pro
is the primary disassembler used by many security researchers. As such,
the severity of this issue is exacerbated when considering the impact of
a fast spreading worm combined with an exploit for this vulnerability.

Although simple modification of an import library name is sufficient to
exploit this vulnerability, the Windows loader will fail to recognize it
as a valid PE file. This will result in a non-executable malicious
binary. iDEFENSE has discovered a method for exploiting this
vulnerability in a fashion that is undetectable via PE import table
entry analysis, and that is affective against IDA Pro and will load and
execute as a regular binary without error.

It should be noted that other applications designed to analyze PE
executables may also be vulnerable. PEiD is a freely available PE
analysis tool and is also susceptible to attack.


iDEFENSE has confirmed the existence of this vulnerability in IDA Pro
versions 4.6 Service Pack 1 and 4.7 on both the Microsoft Windows and
Linux platforms. It is suspected that earlier versions are also


Prior to opening unknown files with vulnerable versions of IDA Pro,
examine the PE import table entries for long or abnormal strings. There
are a number of tools available for analyzing the PE file format. It is
important to note that this method will not catch all exploit vectors.


"A temporary fix is available here

A more generic fix will be available in the next IDA Pro release."


The Common Vulnerabilities and Exposures (CVE) project has assigned the
names CAN-2005-0115 to these issues. This is a candidate for inclusion
in the CVE list (, which standardizes names for
security problems.


01/12/2005      Initial vendor notification
01/12/2005      Initial vendor response
01/24/2005      Coordinated public disclosure


Lord Yup is credited with this discovery.

Get paid for vulnerability research


Copyright (c) 2005 iDEFENSE, Inc.

Permission is granted for the redistribution of this alert
electronically. It may not be edited in any way without the express
written consent of iDEFENSE. If you wish to reprint the whole or any
part of this alert in any other medium other than electronically, please
email for permission.

Disclaimer: The information in the advisory is believed to be accurate
at the time of publishing based on currently available information. Use
of the information constitutes acceptance for use in an AS IS condition.

There are no warranties with regard to this information. Neither the
author nor the publisher accepts any liability for any direct, indirect,
or consequential loss or damage arising from use of, or reliance on,
this information.

- 漏洞信息

Multiple Vendor Portable Executable Import Directory Library Name Overflow
Remote / Network Access Input Manipulation
Loss of Integrity

- 漏洞描述

A remote overflow exists in IDA PRO. IDA PRO fails to perform proper bounds checking within the Portable Executable import directory library resulting in a buffer overflow. With a specially crafted request, an attacker can cause arbitrary code execution resulting in a loss of integrity.

- 时间线

2005-01-24 Unknow
Unknow Unknow

- 解决方案

Currently, there are no known workarounds or upgrades to correct this issue. However, Datarescue has released a patch to address this vulnerability.

- 相关参考

- 漏洞作者

- 漏洞信息

DataRescue IDA Pro Malformed PE File Remote Buffer Overflow Vulnerability
Boundary Condition Error 12353
Yes No
2005-01-24 12:00:00 2009-07-12 10:06:00
Discovery is credited to Lord Yup.

- 受影响的程序版本

DataRescue IDA Pro 4.7
DataRescue IDA Pro 4.6 SP1

- 漏洞讨论

IDA Pro is reported prone to a remote buffer overflow vulnerability. This issue may allow a remote attacker to execute arbitrary code on a vulnerable computer to gain unauthorized access.

An attacker can exploit this issue by crafting a PE file and enticing a user to process the file through IDA Pro.

A successful attack may facilitate unauthorized access to the affected computer.

IDA Pro 4.6 SP 1 and 4.7 running on both Windows and Linux platforms are reported vulnerable to this issue. It is possible that other versions are affected as well.

- 漏洞利用

Currently we are not aware of any exploits for this issue. If you feel we are in error or are aware of more recent information, please mail us at: <>.

- 解决方案

The vendor has released a patch to address this issue.

DataRescue IDA Pro 4.6 SP1

DataRescue IDA Pro 4.7

- 相关参考